if select(6, GetAddOnInfo("CowTip_" .. (debugstack():match("[C%.][o%.][w%.]Tip\\Modules\\(.-)\\") or debugstack():match("[C%.][o%.][w%.]Tip\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 41607 $"):match("%d+"))

local CowTip = CowTip
local CowTip_PowerBar = CowTip:NewModule("PowerBar", "AceEvent-2.0")
local self = CowTip_PowerBar
if CowTip.revision < VERSION then
	CowTip.version = "r" .. VERSION
	CowTip.revision = VERSION
	CowTip.date = ("$Date: 2007-06-24 23:00:14 -0400 (Sun, 24 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end
CowTip.desc = "Allow for a power bar on the tooltip"

local L = CowTip:L("CowTip_PowerBar")

local _G = _G

function CowTip_PowerBar:OnInitialize()
	self.db = CowTip:AcquireDBNamespace("PowerBar")
	CowTip:RegisterDefaults("PowerBar", "profile", {
		size = 5,
		position = "BOTTOM",
	})
end

local powerBar
function CowTip_PowerBar:OnEnable(first)
	self:RegisterEvent("UNIT_MANA")
	self:RegisterEvent("UNIT_RAGE", "UNIT_MANA")
	self:RegisterEvent("UNIT_FOCUS", "UNIT_MANA")
	self:RegisterEvent("UNIT_ENERGY", "UNIT_MANA")
	self:RegisterEvent("UNIT_MAXMANA", "UNIT_MANA")
	self:RegisterEvent("UNIT_MAXRAGE", "UNIT_MANA")
	self:RegisterEvent("UNIT_MAXFOCUS", "UNIT_MANA")
	self:RegisterEvent("UNIT_MAXENERGY", "UNIT_MANA")
	self:RegisterEvent("UNIT_DISPLAYPOWER", "UNIT_MANA")
end

function CowTip_PowerBar:OnDisable()
	powerBar:Hide()
end

function CowTip_PowerBar:UNIT_MANA(unit)
	if not UnitIsUnit(unit, "mouseover") then
		return
	end
	
	self:Update()
end

function CowTip_PowerBar:OnTooltipShow()
	if not PowerBar then
		powerBar = CreateFrame("StatusBar", "CowTip_PowerBar_Bar", GameTooltip)
		powerBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
		powerBar:SetMinMaxValues(0, 1)
		if self.db.profile.position == "TOP" then
			powerBar:SetPoint("BOTTOMLEFT", GameTooltip, "TOPLEFT", 4, 0)
			powerBar:SetPoint("BOTTOMRIGHT", GameTooltip, "TOPRIGHT", -4, 0)
			powerBar:SetHeight(self.db.profile.size)
		elseif self.db.profile.position == "BOTTOM" then
			powerBar:SetPoint("TOPLEFT", GameTooltip, "BOTTOMLEFT", 4, 0)
			powerBar:SetPoint("TOPRIGHT", GameTooltip, "BOTTOMRIGHT", -4, 0)
			powerBar:SetHeight(self.db.profile.size)
		elseif self.db.profile.position == "LEFT" then
			powerBar:SetPoint("TOPRIGHT", GameTooltip, "TOPLEFT", 0, -4)
			powerBar:SetPoint("BOTTOMRIGHT", GameTooltip, "BOTTOMLEFT", 0, 4)
			powerBar:SetWidth(self.db.profile.size)
			powerBar:SetOrientation("VERTICAL")
		elseif self.db.profile.position == "RIGHT" then
			powerBar:SetPoint("TOPLEFT", GameTooltip, "TOPRIGHT", 0, -4)
			powerBar:SetPoint("BOTTOMLEFT", GameTooltip, "BOTTOMRIGHT", 0, 4)
			powerBar:SetWidth(self.db.profile.size)
			powerBar:SetOrientation("VERTICAL")
		end
	end
	
	if not CowTip.currentTooltipUnit then
		powerBar:Hide()
		return
	end
	
	powerBar:Show()
	
	self:Update()
end

function CowTip_PowerBar:OnTooltipHide()
	if not powerBar then
		return
	end
	powerBar:Hide()
end

function CowTip_PowerBar:Update()
	local max = UnitManaMax("mouseover")
	local value
	if max == 0 then
		value = 0
	else
		value = UnitMana("mouseover") / max
	end
	powerBar:SetValue(value)
	local powerType = UnitPowerType("mouseover")
	if powerType == 0 then
		-- mana
		powerBar:SetStatusBarColor(48/255, 113/255, 191/255)
	elseif powerType == 1 then
		-- rage
		powerBar:SetStatusBarColor(226/255, 45/255, 75/255)
	elseif powerType == 2 then
		-- focus
		powerBar:SetStatusBarColor(1, 210/255, 0)
	else
		-- energy
		powerBar:SetStatusBarColor(1, 220/255, 25/255)
	end
end

function CowTip_PowerBar:SetSize(size)
	self.db.profile.size = size
	if not powerBar then
		return
	end
	powerBar:SetHeight(size)
end

function CowTip_PowerBar:SetPosition(position)
	self.db.profile.position = position
	if not powerBar then
		return
	end
	powerBar:SetWidth(0)
	powerBar:SetHeight(0)
	powerBar:ClearAllPoints()
	if position == "TOP" then
		powerBar:SetPoint("BOTTOMLEFT", GameTooltip, "TOPLEFT", 4, 0)
		powerBar:SetPoint("BOTTOMRIGHT", GameTooltip, "TOPRIGHT", -4, 0)
		powerBar:SetHeight(self.db.profile.size)
		powerBar:SetOrientation("HORIZONTAL")
	elseif position == "BOTTOM" then
		powerBar:SetPoint("TOPLEFT", GameTooltip, "BOTTOMLEFT", 4, 0)
		powerBar:SetPoint("TOPRIGHT", GameTooltip, "BOTTOMRIGHT", -4, 0)
		powerBar:SetHeight(self.db.profile.size)
		powerBar:SetOrientation("HORIZONTAL")
	elseif position == "LEFT" then
		powerBar:SetPoint("TOPRIGHT", GameTooltip, "TOPLEFT", 0, -4)
		powerBar:SetPoint("BOTTOMRIGHT", GameTooltip, "BOTTOMLEFT", 0, 4)
		powerBar:SetWidth(self.db.profile.size)
		powerBar:SetOrientation("VERTICAL")
	elseif position == "RIGHT" then
		powerBar:SetPoint("TOPLEFT", GameTooltip, "TOPRIGHT", 0, -4)
		powerBar:SetPoint("BOTTOMLEFT", GameTooltip, "BOTTOMRIGHT", 0, 4)
		powerBar:SetWidth(self.db.profile.size)
		powerBar:SetOrientation("VERTICAL")
	end
end

CowTip_PowerBar:RegisterCowTipOption({
	name = L["Power bar"],
	desc = L["Change settings for the power bar."],
	type = 'group',
	args = {
		size = {
			type = 'range',
			name = L["Size"],
			desc = L["The size of the power bar."],
			get = function()
				return CowTip_PowerBar.db.profile.size
			end,
			set = "SetSize",
			min = 1,
			max = 20,
			step = 1,
		},
		position = {
			type = 'text',
			name = L["Position"],
			desc = L["The position of the power bar relative to the tooltip."],
			get = function()
				return CowTip_PowerBar.db.profile.position
			end,
			set = "SetPosition",
			validate = {
				LEFT = L["Left"],
				RIGHT = L["Right"],
				TOP = L["Top"],
				BOTTOM = L["Bottom"],
			}
		}
	}
})